/// 407!3 +/ \!<07!\*
#include <bits/stdc++.h>
#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")

using namespace std;

using ll = long long;
using db = long double; // or double, if TL is tight
using str = string; // yay python!

using pi = pair<int,int>;
using pl = pair<ll,ll>;
using pd = pair<db,db>;

using vi = vector<int>;
using vb = vector<bool>;
using vl = vector<ll>;
using vd = vector<db>;
using vs = vector<str>;
using vpi = vector<pi>;
using vpl = vector<pl>;
using vpd = vector<pd>;
using vvi = vector<vi>;
using vvl = vector<vl>;
using vvpi = vector<vpi>;

template<class T> using pq = priority_queue<T>;
template<class T> using pqg = priority_queue<T, vector<T>, greater<T>>;

// pairs
#define mp make_pair
#define f first
#define s second

// vectors
#define sz(x) int((x).size())
#define bg(x) begin(x)
#define all(x) bg(x), end(x)
#define rall(x) x.rbegin(), x.rend()
#define sor(x) sort(all(x))
#define rsz resize
#define ins insert
#define ft front()
#define bk back()
#define pb push_back
#define eb emplace_back
#define pf push_front
#define er erase
#define ub upper_bound
#define lb lower_bound

// loops
#define FOR(i,a,b) for (int i = (a); i < (b); ++i)
#define F0R(i,a) FOR(i,0,a)
#define ROF(i,a,b) for (int i = (b)-1; i >= (a); --i)
#define R0F(i,a) ROF(i,0,a)
#define trav(a,x) for (auto& a: x)

const int MOD = 1e9+7; // 998244353;
const int MX = 2e5+5;
const ll INF = 1e18; // not too close to LLONG_MAX
const db PI = acos((db)-1);
const int dx[4] = {1,0,-1,0}, dy[4] = {0,1,0,-1}; // for every grid problem!
const char nl = '\n';

template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void __print(int x) {cerr << x;}
void __print(long x) {cerr << x;}
void __print(long long x) {cerr << x;}
void __print(unsigned x) {cerr << x;}
void __print(unsigned long x) {cerr << x;}
void __print(unsigned long long x) {cerr << x;}
void __print(float x) {cerr << x;}
void __print(double x) {cerr << x;}
void __print(long double x) {cerr << x;}
void __print(char x) {cerr << '\'' << x << '\'';}
void __print(const char *x) {cerr << '\"' << x << '\"';}
void __print(const string &x) {cerr << '\"' << x << '\"';}
void __print(bool x) {cerr << (x ? "true" : "false");}

template<typename T, typename V>
void __print(const pair<T, V> &x) {cerr << '{'; __print(x.first); cerr << ", "; __print(x.second); cerr << '}';}
template<typename T>
void __print(const T &x) {int f = 0; cerr << '{'; for (auto &i: x) cerr << (f++ ? ", " : ""), __print(i); cerr << "}\n";}
void _print() {cerr << "\n";}
template <typename T, typename... V>
void _print(T t, V... v) {__print(t); if (sizeof...(v)) cerr << ", "; _print(v...);}

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

template<typename T>
using indexed_set =  tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define ook order_of_key
#define fbo find_by_order

void _input() {return;}
template <typename T, typename... V>
void _input(T &t, V&... v) {cin >> (t); if (sizeof...(v))  _input(v...);}
void __input(vi &v, const int n){F0R(i, n)cin >> v[i];}
void __input(vvi &v, const int n, const int m){F0R(i, n)F0R(j, m)cin>>v[i][j];}

ll binpow(ll a, ll b) {
    ll res = 1;
    while (b > 0) {
        if (b & 1)
            res = res * a;
        a = a * a;
        b >>= 1;
    }
    return res;
}

struct pt {
    ll x, y;
    bool operator == (pt const& t) const {
        return x == t.x && y == t.y;
    }
};

int orientation(pt a, pt b, pt c) {
    ll v = a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y);
    if (v < 0) return -1; // clockwise
    if (v > 0) return +1; // counter-clockwise
    return 0;
}

bool cw(pt a, pt b, pt c) {
    int o = orientation(a, b, c);
    return o < 0;
}


vector<pt> convex_hull(vector<pt>& a, vi &ind) {
    pt p0 = *min_element(all(a), [](pt a, pt b) {
        return make_pair(a.y, a.x) < make_pair(b.y, b.x);
    });

    sort(all(a), [&p0](const pt& a, const pt& b) {
        int o = orientation(p0, a, b);
        if (o == 0)
            return (p0.x-a.x)*(p0.x-a.x) + (p0.y-a.y)*(p0.y-a.y)
                < (p0.x-b.x)*(p0.x-b.x) + (p0.y-b.y)*(p0.y-b.y);
        return o < 0;
    });

    vector<pt> st;
    F0R(i, sz(a)) {
        while (sz(st) > 1 && !cw(st[sz(st) - 2], st.back(), a[i])){
            st.pop_back();
            ind.pop_back();
        }
        st.pb(a[i]);
        ind.pb(i);
    }
    return st;
}

vector<pt> convex_hull_2(vector<pt> &a, int s, int e, int no){
    vector<pt> st;
    if(e < s){
        FOR(i, s, sz(a)){
            if(i == no)continue;
            while(sz(st) > 1 && !cw(st[sz(st) - 2], st.back(), a[i]))st.pop_back();
            st.pb(a[i]);
        }
        F0R(i, e + 1){
            if(i == no)continue;
            while(sz(st) > 1 && !cw(st[sz(st) - 2], st.back(), a[i]))st.pop_back();
            st.pb(a[i]);
        }
    }
    else{
        FOR(i, s, e + 1){
            if(i == no)continue;
            while(sz(st) > 1 && !cw(st[sz(st) - 2], st.back(), a[i]))st.pop_back();
            st.pb(a[i]);
        }
    }
    return st;
}

ll area(vector<pt>& a){
    ll area = 0;
    int n = sz(a), j = n - 1;
    F0R(i, n){
        area += ((a[i].x + a[j].x) * (a[i].y - a[j].y)) / 2;
        j = i;
    }
    return abs(area);

}

void solve(){
    int n;
    cin >> n;
    vector<pt> v(n), au(n - 1);
    F0R(i, n)cin >> v[i].x >> v[i].y;
    vi ind;
    vector<pt> conv = convex_hull(v, ind);
    ll sarea = area(conv), mxarea = 0;
    FOR(i, 1, n)au[i - 1] = v[i];
    int m = sz(ind);
    F0R(i, m - 1){
        int j = (i + 2) % m, no = (i + 1) % m;
        vector<pt> cur = convex_hull_2(v, ind[i], ind[j], ind[no]);
        vector<pt> triangle = {v[ind[i]], v[ind[no]], v[ind[j]]};
        ll carea = area(triangle);
        if(sz(cur) != 2){
            vi rand;
            carea -= area(cur);
        }
        mxarea = max(mxarea, carea);
    }
    vi rand2;
    vector<pt> auconv = convex_hull(au, rand2);
    cout << min(sarea - mxarea, area(auconv)) << nl;
}


/*


*/

int main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    int t; t = 1;while(t--){
        solve();
    }
    return 0;
}